/*
 * Progetto 8 capitolo 3 del libro Savitch.
 * 
 * Scrivere un programma che legga una stringa dalla tastiera e che
 * verifichi se questa contiene una data valida.
 * Si mostri la data e un messaggio che indica se questa e' valida.
 * Se non  valida si mostri inoltre un messaggio che ne spieghi il motivo.
 * La data in input deve avere il formato gg/mm/aaaa. 
 * Un valore valido per il mese mm deve essere compreso tra 1 e 12.
 * Un valore valido per il giorno gg deve essere incluso tra 1 e un
 * valore corretto per quel mese.
 * Si consideri l'effetto degli anni bisestili.
 */

import java.util.*;

public class DataValida {
	
	public static void main(String[] args){
		
		Scanner tastiera = new Scanner(System.in);
		
		// acquisizione della data
		System.out.print("Inserire la data nel formato gg/mm/aaaa: ");
		String data = tastiera.next();
		
		// estrazione di giorno, mese e anno
		int giorno = Integer.parseInt(data.substring(0,data.indexOf("/"))); 
		// non si e' scelto l'indice 2 perche' non si ha garanzia che l'utente 
		// non inserisca giorni a cifra singola, ad esempio, 3/10/2015
		int mese = Integer.parseInt(data.substring(data.indexOf("/")+1,data.lastIndexOf("/")));
		int anno = Integer.parseInt(data.substring(data.lastIndexOf("/")+1));
		
		if(anno >= 0){
			switch(mese){
				case 1:
				case 3:
				case 5:
				case 7:
				case 8:
				case 10:
				case 12:
					if(giorno >=1 && giorno <= 31)
						System.out.println("Data corretta");
					else
						System.out.println("Giorno fuori dai limiti");
					break;
				case 4:
				case 6:
				case 9:
				case 11:
					if(giorno >=1 && giorno <= 30)
						System.out.println("Data corretta");
					else
						System.out.println("Giorno fuori dai limiti");
					break;
				case 2:
					int giorniFebbraio;
					if(anno%4 == 0 && (anno%100 != 0 || anno%400 == 0))
						// anno bisestile
						giorniFebbraio = 29;
					else
						giorniFebbraio = 28;
					if(giorno >= 1 && giorno <= giorniFebbraio)
						System.out.println("Data corretta");
					else
						System.out.println("Giorno fuori dai limiti");
					break;
				default:
					System.out.println("Errore: valore di mese non corretto (1-12)");
				}
		}
		else
			System.out.println("Errore: valore di anno negativo");
		
		tastiera.close();
	}

}
